unit fUtils;

interface

uses Windows, Classes, SysUtils;

  function GetConInputHandle: THandle;
  function GetConOutputHandle: THandle;
  procedure Init;
  procedure GotoXY(X, Y: Word);
  procedure Cls;
  procedure ShowCursor(Show: Bool);
  function ConProc(CtrlType: DWord): Bool; stdcall; far;

  procedure ShowMenu();
  function SmallRect(Left, Top, Right, Bottom: Smallint): TSmallRect;

  function FindMax: Integer;
  function FindMin: Integer;
  function FindAve: Single;
  function InputRainFallOfMonth(Month: Integer): string;

  procedure DO_FUNC_1;

const
  MM: array[1..12] of string = (
    '@','G','T','|','','','C','K','E','Q','Q@','QG');

  THE_MENU: array[1..9] of string = (
    '1. 䤤1Ӥ몺Bq',
    '2. p12Ӥ̭Bq̤֬Oh?',
    '3. ̦hSOh?',
    '4. O@~Bq',
    '5. 1-12몺Bq',
    '6. ܨ䤤@ӤBq(ܤ)?:',
    '7. ',
    '',
    'пܥ\ 1~7, Ϋ <ESC> {...'
  );

var
  ConHandle : THandle;
  MaxX, MaxY: Smallint;
  NOAW      : Cardinal;
  Coord     : TCoord;
  CCI       : TConsoleCursorInfo;
  Continue  : Bool = True;

  R        : TSmallRect;
  Color    : Word;
  IBuff    : TInputRecord;
  IEvent   : DWord;
  RainFall : array[1..12] of Integer;//OBq
  Mon      : Integer;
  X        : string;

implementation

procedure Init;
begin
  // Get console output handle
  ConHandle := GetConOutputHandle;
  // Get max window size
  Coord := GetLargestConsoleWindowSize(ConHandle);
  MaxX := Coord.X;
  MaxY := Coord.Y;
end;

function GetConInputHandle: THandle;
begin
  Result := GetStdHandle(STD_INPUT_HANDLE);
end;

function GetConOutputHandle : THandle;
begin
  Result := GetStdHandle(STD_OUTPUT_HANDLE);
end;

procedure GotoXY(X, Y : Word);
begin
  Coord.X := X; Coord.Y := Y;
  SetConsoleCursorPosition(ConHandle, Coord);
end;

procedure Cls;
begin
  Coord.X := 0; Coord.Y := 0;
  FillConsoleOutputCharacter(ConHandle, ' ', MaxX*MaxY, Coord, NOAW);
  GotoXY(0, 0);
end;

procedure ShowCursor(Show: Bool);
begin
  CCI.bVisible := Show;
  SetConsoleCursorInfo(ConHandle, CCI);
end;

function ConProc(CtrlType: DWord): Bool; stdcall; far;
begin
  case CtrlType of
    CTRL_CLOSE_EVENT: Continue := False;
  end;
  Result := True;
end;

procedure ShowMenu();
var
  I: Integer;
begin
  Cls;
  for I := Low(THE_MENU) to High(THE_MENU) do
    Writeln(THE_MENU[I]);
end;

function SmallRect(Left, Top, Right, Bottom: Smallint): TSmallRect;
begin
  Result.Left := Left;
  Result.Top := Top;
  Result.Right := Right;
  Result.Bottom := Bottom;
end;

function FindMax: Integer;
var
  I: Integer;
begin
  Result := 0;
  for I := Low(RainFall) to High(RainFall) do
    if RainFall[I] > Result then
      Result := RainFall[I];
end;

function FindMin: Integer;
var
  I: Integer;
begin
  Result := 0;
  for I := Low(RainFall) to High(RainFall) do
  begin
    if I = 0 then
      Result := RainFall[I]
    else if RainFall[I] < Result then
      Result := RainFall[I];
  end;
end;

function FindAve: Single;
var
  I, Sum: Integer;
begin
  Sum := 0;
  for I := Low(RainFall) to High(RainFall) do
    Sum := Sum + RainFall[I];
  Result := Sum / 12;
end;

function InputRainFallOfMonth(Month: Integer): string;
begin
  Write('J'+MM[Month]+'Bq: ');
  Readln(Result);//Ūæ^
end;

procedure DO_FUNC_1;
var
  S: string;
  M: Integer;
begin
  Write('Jnק諸: ');
  Readln(S);
  M := StrToIntDef(S, 0);
  if not M in [1..12] then
    MessageBox(0, 'J~!!!', 'Win32 Console', MB_OK)
  else begin
    S := InputRainFallOfMonth(M);//JBq;
    if Trim(S) <> '-1' then
    begin
      RainFall[M] := StrToIntDef(S, 0);
      Writeln(IntToStr(M) + 'Bq = ' + IntToStr(RainFall[M]));
      Writeln;
      Writeln('Ы@~.......');
      Readln;
    end;
    ShowMenu;
  end;
end;

end.
